![Kriptomatte_icon.png](Kriptomatte_icon.png)
# Kriptomatte: 画家的Cryptomatte解决方案
Kriptomatte旨在将 Cryptomatte 功能引入 Krita，一款流行的开源绘画软件。

[English](readme.md)
## 这里的代码是什么

Kriptomatte 是一款帮助艺术家处理 Cryptomattes 的工具。
Cryptomattes 是嵌入 EXR 图像文件中的特殊蒙版。
这些蒙版隔离对象、材质和资产，使它们在视频后期处理软件中更容易选择和操作。

不幸的是，2D 图像编辑软件不能读取EXR文件中的Cryptomattes，因此画家通常依赖 ID Pass。
但许多流行的软件包，如 Blender，不支持渲染 ID Pass。
本仓库（Kriptomatte 第一阶段）中的代码提供了一个解决方案：
Kriptomatte 将 Cryptomatte 信息转换为类似 ID Pass的蒙版（Mask），这些蒙版为单纯的PNG图像，可以导入Krita、Photoshop 和 Clip Studio 等绘画软件中。

![Kriptomatte Sample.png](Kriptomatte%20Sample.png)

程序也会输出各物体的单独精细Mask。

![Kriptomatte_Seperate_Mask.png](Kriptomatte_Seperate_Mask.png)

## 项目规划

Kriptomatte 项目分为四个阶段：

### 一期：Python脚本

https://pypi.org/project/kriptomatte/

本阶段专注于创建一个 Python 脚本，用于从 EXR 文件中提取 Cryptomatte 信息并将其转换为带有 alpha 通道的 PNG 图像。
这让画家更容易用上 Cryptomattes。
他们可以使用这些 PNG 在他们喜欢的任何软件中进行修改。

### 二期：C++程序

我在第二阶段将用 C++ 重写 Python 脚本，创建一个更快的独立可执行程序。
该程序更容易使用，画家只需将他们的 EXR 文件拖放到可执行文件上即可生成 PNG。

### Phase 3a & 3b: Krita Integration

在最后，我将把 Kriptomatte 功能直接集成到 Krita 中。
3a 阶段将专注于创建代码的 C++ 版本，而 3b 阶段为 Krita 的 Python 插件。

# 用法

## 安装 

您可以使用命令提示符（也称为终端）中的 `pip` 安装脚本。如果您不熟悉这个概念，可以把它想象成一个特殊的窗口，您可以在其中输入命令让计算机执行。以下是如何在 Windows 上打开它的方法：按住 `Shift` 并右键单击桌面，然后选择 **“在此处打开 PowerShell”** 或 **“在此处打开 Windows 终端”**。 终端打开后，复制并粘贴以下命令之一进行安装：

```bash
python -m pip install kriptomatte
# or
pip install kriptomatte
```

## 使用

安装完成后，您可以在终端中使用该脚本。
再次打开终端，打开 EXR 文件所在目录，运行以下命令，将 `path/to/your/file.exr` 替换为您文件的实际路径：

在 Windows 上轻松获取 EXR 文件的路径，左键单击文件，然后按 alt + 3。
这会将文件位置复制到您的剪贴板。然后您可以将其粘贴到命令中。
如果快捷键不起作用，您可以在文件资源管理器的左上角找到一个浅蓝色的选项来复制文件路径。

```bash
kriptomatte -i "path to your exr file"
# for example
kriptomatte  -i "C:\Users\GrandArth\Pictures\sample.exr"
```

## Important Note:

目前，脚本仅支持存储在 32 位 EXR 文件中的 Cryptomattes。确保您的 EXR 文件以 32 位精度渲染，以使脚本正常工作。

# Code Reference

```ref
Friedman, Jonah, and Andrew C. Jones. 2015. “Fully Automatic ID Mattes with Support for Motion Blur and Transparency.” In ACM SIGGRAPH 2015 Posters, 1–1. Los Angeles California: ACM. https://doi.org/10.1145/2787626.2787629.
“OpenEXR Bindings for Python.” n.d. Accessed July 17, 2024. https://www.excamera.com/sphinx/articles-openexr.html.
“Psyop/Cryptomatte.” (2015) 2024. Python. Psyop. https://github.com/Psyop/Cryptomatte.
“Synthesis-AI-Dev/Exr-Info: Package with Helper Modules to Process EXR Files Generated by Renders.” n.d. Accessed July 21, 2024. https://github.com/Synthesis-AI-Dev/exr-info.
```